/* Copyright 2007, 2008 DJ Delorie <dj@delorie.com>
   Distributed under the terms of the GNU General Public License
   version 3, see COPYING-3.0 for details.
*/
/* These are all defined in main, which just removes all the
   "extern"s.  */

typedef struct
{
  byte show_time:1;
  byte check_net_time:1;
  byte new_net_time:1;
  byte rtc_need_redisplay:1;
  byte check_volume:1;
  byte reset_volume_val:1;
  byte reset_volume_bar:1;
} ToDo;

extern ToDo todo;

typedef struct
{
  byte muted:1;
} Status;

extern Status status;

extern char adc_debug;
extern char local_console;

typedef enum
{
  TOC_TOC,
  TOC_config,
  TOC_alarm,
  TOC_web,
  TOC_string,
  TOC_console_font,
  TOC_main_font,
  TOC_night_font,
  TOC_half_font,
  TOC_mini_font,
  TOC_default_beep,
  TOC_mp3_silence,
  TOC_image_intro,
  TOC_image_iok,
  TOC_image_icancel,
  TOC_image_iup,
  TOC_image_idown,
  TOC_image_ileft,
  TOC_image_iright,
  TOC_image_ihz,
  TOC_image_idb,
  TOC_image_ionoff,
  TOC_image_iset,
  TOC_image_rarrow16,
  TOC_image_larrow16,
  TOC_image_ilouder,
  TOC_image_iquieter,
  TOC_image_svolume,
  TOC_MAX
} TOCindexes;

typedef struct
{
  word addr;
  word size;
} TOC_Entry;

typedef struct
{
  byte tz_offset;
  byte zen_setting;
  byte sleep_volume;
  byte rtc_calib;
  byte disp_24hr;
} ConfigStruct;

typedef struct
{
  byte hour;
  byte minute;
  byte dow;
  byte month;
  byte day;
  byte zen;
  word web __attribute__ ((packed));
} AlarmStruct;

#define ConfigOffset(x) ((int)(&(((ConfigStruct*)0)->x)))

typedef struct
{
  byte type;
  byte width;
  byte height;
} ImageHeader;

typedef struct
{
  word mp3_url_addr;
  word image_url_addr;
  word name_addr;
} WebDestination;

// A button event with button==0 means "timeout"
extern byte button_event;
extern byte button;		// 0..7 (0 is "no button"), +8 for repeating
extern byte button_autorepeat;	// bits 1..7 set if autorepeating desired
extern int volume;		// 0..0x3ff
extern byte photocell;		// 0..15

#define B1 0x02
#define B2 0x04
#define B3 0x08
#define B4 0x10
#define B5 0x20
#define B6 0x40
#define B8 0x80

extern byte hour, hour12, pm, minute, second;
extern byte month, day, year, dow;

// Monotonically increasing value for measuring timeouts and whatnot.
extern int eseconds;

// Seconds left on the sleep timer.  Zero means off.
extern int sleep_time;

#ifdef INVALID_SOCKET
extern TCP_SOCKET mp3_url_socket;
#endif

typedef enum
{
  PLAY_NONE,
  PLAY_BEEP,
  PLAY_URL,
  PLAY_SERVER
} Play_Source;
extern Play_Source play_source;

/* main font glyphs */
#define AM	10
#define PM	11
#define COLON	12
#define MID	13
#define NOON	14
