/* Copyright 2007, 2008 DJ Delorie <dj@delorie.com>
   Distributed under the terms of the GNU General Public License
   version 3, see COPYING-3.0 for details.
*/
#include "pins.h"
#include "TCPIP Stack/TCPIP.h"

APP_CONFIG AppConfig;

#define packip(a,b,c,d) ((a) | ((b)<<8ul) | ((unsigned long)(c)<<16ul) | ((unsigned long)(d)<<24ul))

void
InitAppConfig ()
{
  AppConfig.Flags.bIsDHCPEnabled = TRUE;
  AppConfig.Flags.bInConfigMode = TRUE;
  AppConfig.MyMACAddr.v[0] = MY_DEFAULT_MAC_BYTE1;
  AppConfig.MyMACAddr.v[1] = MY_DEFAULT_MAC_BYTE2;
  AppConfig.MyMACAddr.v[2] = MY_DEFAULT_MAC_BYTE3;
  AppConfig.MyMACAddr.v[3] = MY_DEFAULT_MAC_BYTE4;
  AppConfig.MyMACAddr.v[4] = MY_DEFAULT_MAC_BYTE5;
  AppConfig.MyMACAddr.v[5] = MY_DEFAULT_MAC_BYTE6;
  AppConfig.MyIPAddr.Val =
    packip (MY_DEFAULT_IP_ADDR_BYTE1, MY_DEFAULT_IP_ADDR_BYTE2,
	    MY_DEFAULT_IP_ADDR_BYTE3, MY_DEFAULT_IP_ADDR_BYTE4);
  AppConfig.DefaultIPAddr.Val = AppConfig.MyIPAddr.Val;
  AppConfig.MyMask.Val =
    MY_DEFAULT_MASK_BYTE1 | MY_DEFAULT_MASK_BYTE2 << 8ul |
    MY_DEFAULT_MASK_BYTE3 << 16ul | MY_DEFAULT_MASK_BYTE4 << 24ul;
  AppConfig.DefaultMask.Val = AppConfig.MyMask.Val;
  AppConfig.MyGateway.Val =
    MY_DEFAULT_GATE_BYTE1 | MY_DEFAULT_GATE_BYTE2 << 8ul |
    MY_DEFAULT_GATE_BYTE3 << 16ul | MY_DEFAULT_GATE_BYTE4 << 24ul;
  AppConfig.DHCPServer.IPAddr.Val = packip (1, 2, 3, 4);
  AppConfig.PrimaryDNSServer.Val =
    MY_DEFAULT_PRIMARY_DNS_BYTE1 | MY_DEFAULT_PRIMARY_DNS_BYTE2 << 8ul |
    MY_DEFAULT_PRIMARY_DNS_BYTE3 << 16ul | MY_DEFAULT_PRIMARY_DNS_BYTE4 <<
    24ul;
  AppConfig.SecondaryDNSServer.Val =
    MY_DEFAULT_SECONDARY_DNS_BYTE1 | MY_DEFAULT_SECONDARY_DNS_BYTE2 << 8ul |
    MY_DEFAULT_SECONDARY_DNS_BYTE3 << 16ul | MY_DEFAULT_SECONDARY_DNS_BYTE4 <<
    24ul;

  // Load the default NetBIOS Host Name
  memcpy (AppConfig.NetBIOSName, (void *) MY_DEFAULT_HOST_NAME, 16);
}
